exercises/relations/config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  # BEGIN
  resources :statuses
  resources :users
  resources :tasks
  # END
  
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  root 'home#index'
end

exercises/relations/app/models/application_record.rb
# frozen_string_literal: true

class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

exercises/relations/app/models/status.rb
# frozen_string_literal: true

class Status < ApplicationRecord
  # BEGIN
  has_many :tasks
  # END
end

exercises/relations/app/models/task.rb
# frozen_string_literal: true

class Task < ApplicationRecord
  belongs_to :user, optional: true
  belongs_to :status, optional: true
end

exercises/relations/app/models/user.rb
# frozen_string_literal: true

class User < ApplicationRecord
  # BEGIN
  has_many :tasks
  # END
end

exercises/relations/app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
end

exercises/relations/app/controllers/home_controller.rb
# frozen_string_literal: true

class HomeController < ApplicationController
  def index; end
end

exercises/relations/app/controllers/statuses_controller.rb
# frozen_string_literal: true

class StatusesController < ApplicationController
  before_action :set_status, only: %i[show edit update destroy]

  def index
    @statuses = Status.all
  end

  def show; end

  def new
    @status = Status.new
  end

  def edit; end

  def create
    @status = Status.new(status_params)

    if @status.save
      redirect_to @status, notice: 'Status was successfully created.'
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    if @status.update(status_params)
      redirect_to @status, notice: 'Status was successfully updated.'
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @status.destroy

    redirect_to statuses_url, notice: 'Status was successfully destroyed.'
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_status
    @status = Status.find(params[:id])
  end

  # Only allow a list of trusted parameters through.
  def status_params
    params.require(:status).permit(:name)
  end
end

exercises/relations/app/controllers/tasks_controller.rb
# frozen_string_literal: true

class TasksController < ApplicationController

  before_action :set_task, only: %i[show edit update destroy]

  def index
    @tasks = Task.all
  end

  def show; end

  def new
    @task = Task.new
  end

  def edit; end

  def create
    @task = Task.new(task_params)

    if @task.save
      redirect_to @task, notice: 'Task was successfully created.'
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    if @task.update(task_params)
      redirect_to @task, notice: 'Task was successfully updated.'
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @task.destroy

    redirect_to tasks_url, notice: 'Task was successfully destroyed.'
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_task
    @task = Task.find(params[:id])
  end

  # Only allow a list of trusted parameters through.
  def task_params
    params.require(:task).permit(:name, :description, :user_id, :status_id)
  end
end

exercises/relations/app/controllers/users_controller.rb
# frozen_string_literal: true

class UsersController < ApplicationController
  before_action :set_user, only: %i[show edit update destroy]

  def index
    @users = User.all
  end

  def show
    user = User.find params[:id]

    @tasks = user.tasks
  end

  def new
    @user = User.new
  end

  def edit; end

  def create
    @user = User.new(user_params)

    if @user.save
      redirect_to @user, notice: 'User was successfully created.'
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    if @user.update(user_params)
      redirect_to @user, notice: 'User was successfully updated.'
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @user.destroy

    redirect_to users_url, notice: 'User was successfully destroyed.'
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_user
    @user = User.find(params[:id])
  end

  # Only allow a list of trusted parameters through.
  def user_params
    params.require(:user).permit(:name)
  end
end

exercises/relations/app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
end

exercises/relations/app/helpers/tasks_helper.rb
module TasksHelper
end

exercises/relations/app/views/layouts/shared/_nav.html.slim
.navbar.navbar-expand-md.navbar-light
  a.navbar-brand.me-md-4(href='/')
    = image_tag 'logo.png', width: 30, alt: 'Hexlet logo'

  #navbarToggler.collapse.navbar-collapse
    ul.nav.nav-pills.flex-grow-1.navbar-nav
      li.nav-item.me-2
        = link_to 'Home', root_path, class: 'nav-link text-dark'
      li.nav-item.me-2
        = link_to 'Tasks', tasks_path, class: 'nav-link text-dark'
      li.nav-item.me-2
        = link_to 'Statuses', statuses_path, class: 'nav-link text-dark'
      li.nav-item.me-2
        = link_to 'Users', users_path, class: 'nav-link text-dark'

exercises/relations/app/views/tasks/_form.html.slim
= simple_form_for(@task) do |f|
  = f.error_notification
  = f.error_notification message: f.object.errors[:base].to_sentence if f.object.errors[:base].present?

  = f.input :name
  = f.input :description
  = f.association :status
  = f.association :user

  = f.button :submit, class: 'btn btn-success mt-4 btn-block'

exercises/relations/app/views/tasks/edit.html.slim
= content_for :title do
  = 'Editing task'

== render 'form'

hr

.d-flex
  = link_to 'Show', @task, class: 'btn btn-outline-primary me-2'
  = link_to 'Back', :back, class: 'btn btn-outline-primary'

exercises/relations/app/views/tasks/index.html.slim
= content_for :title do
  = 'Tasks'

table.table.table-striped.table-hover.mb-5
  thead
    tr
      th{ scope: :col } #
      th{ scope: :col } Name
      th{ scope: :col } User
      th{ scope: :col } Status
      th

  tbody
    - @tasks.each_with_index do |task, i|
      tr
        th{ scope: :col } = i + 1
        td = task.name
        td = "#{task.user ? task.user.name : 'undefined'}"
        td = "#{task.status ? task.status.name : 'undefined'}"
        td.d-flex
          .me-4 = link_to 'Show', task
          .me-4 = link_to 'Edit', edit_task_path(task)
          = link_to 'Destroy', task, data: { confirm: 'Are you sure?' }, method: :delete

= link_to 'New Task', new_task_path, class: 'btn btn-primary'

exercises/relations/app/views/tasks/new.html.slim
= content_for :title do
  = 'New task'

== render 'form'

hr

= link_to 'Back', :back, class: 'btn btn-outline-primary'

exercises/relations/app/views/tasks/show.html.slim
= content_for :title do
  p= @task.name
  p= @task.description
  p= "User: #{@task.user ? @task.user.name : 'undefined'}"
  p= "Status: #{@task.status ? @task.status.name : 'undefined'}"


.d-flex
  = link_to 'Edit', edit_task_path(@task), class: 'btn btn-outline-primary me-2'
  = link_to 'Back', :back, class: 'btn btn-outline-primary'